zoukankan      html  css  js  c++  java
  • POJ3071

    Consider a single-elimination football tournament involving 2n teams, denoted 1, 2, …, 2n. In each round of the tournament, all teams still in the tournament are placed in a list in order of increasing index. Then, the first team in the list plays the second team, the third team plays the fourth team, etc. The winners of these matches advance to the next round, and the losers are eliminated. After nrounds, only one team remains undefeated; this team is declared the winner.

    Given a matrix P = [pij] such that pij is the probability that team i will beat teamj in a match determine which team is most likely to win the tournament.

    Input

    The input test file will contain multiple test cases. Each test case will begin with a single line containing n (1 ≤ n ≤ 7). The next 2n lines each contain 2n values; here, the jth value on the ith line represents pij. The matrix P will satisfy the constraints that pij = 1.0 − pji for all i ≠ j, and pii = 0.0 for all i. The end-of-file is denoted by a single line containing the number −1. Note that each of the matrix entries in this problem is given as a floating-point value. To avoid precision problems, make sure that you use either the double data type instead offloat.

    Output

    The output file should contain a single line for each test case indicating the number of the team most likely to win. To prevent floating-point precision issues, it is guaranteed that the difference in win probability for the top two teams will be at least 0.01.

    Sample Input

    2
    0.0 0.1 0.2 0.3
    0.9 0.0 0.4 0.5
    0.8 0.6 0.0 0.6
    0.7 0.5 0.4 0.0
    -1

    Sample Output

    2

    Hint

    In the test case above, teams 1 and 2 and teams 3 and 4 play against each other in the first round; the winners of each match then play to determine the winner of the tournament. The probability that team 2 wins the tournament in this case is:

    P(2 wins)  P(2 beats 1)P(3 beats 4)P(2 beats 3) + P(2 beats 1)P(4 beats 3)P(2 beats 4)
    p21p34p23 + p21p43p24
    = 0.9 · 0.6 · 0.4 + 0.9 · 0.4 · 0.5 = 0.396.

    The next most likely team to win is team 3, with a 0.372 probability of winning the tournament.

     
    这个就是我这篇文章的例题,题解注释在代码上了。
     1 #include<cstdio>
     2 #include<iostream>
     3 #include<algorithm>
     4 #include<cstring>
     5 #include<cmath>
     6 #define N 207
     7 using namespace std;
     8 
     9 double dp[10][N];//dp[i][j]表示在第i场比赛中j胜出的概率
    10 double p[N][N];
    11 int main()
    12 {
    13     int n;
    14     while(scanf("%d",&n)&&n!=-1)
    15     {
    16         memset(dp,0,sizeof(dp));
    17         for(int i=0;i<(1<<n);i++)
    18             for(int j=0;j<(1<<n);j++)
    19                 scanf("%lf",&p[i][j]);
    20         for(int i=0;i<(1<<n);i++)
    21             dp[0][i]=1;//初始化的概率就是自己 
    22         for(int i=1;i<=n;i++)//2^n个人要进行n场比赛
    23         {
    24             for(int j=0;j<(1<<n);j++)
    25             {
    26                 int t=j/(1<<(i-1));
    27                 t^=1;//转反,就比如1找2,2找1 
    28                 dp[i][j]=0;
    29                 for(int k=t*(1<<(i-1));k<t*(1<<(i-1))+(1<<(i-1));k++)//找到哪两组比赛,加法原理,加概率 
    30                     dp[i][j]+=dp[i-1][j]*dp[i-1][k]*p[j][k];
    31             }
    32         }
    33         int ans=0;double temp=0;
    34         for(int i=0;i<(1<<n);i++)
    35         {
    36             if(dp[n][i]>temp)
    37             {
    38                 ans=i;
    39                 temp=dp[n][i];
    40             }
    41         }
    42         printf("%d
    ",ans+1);
    43     }
    44 }
  • 相关阅读:
    BZOJ 2005 能量采集
    HDU 2841 Visible Trees(莫比乌斯反演)
    hihocoder 1543
    hihocoder 1311
    hdu 6069
    hdu 6058
    hdu 6034
    拓展欧几里得
    poj 3321
    树状数组总结
  • 原文地址:https://www.cnblogs.com/fengzhiyuan/p/7673994.html
Copyright © 2011-2022 走看看